datablock AudioProfile(BoltRifleReloadSound)
{
   filename    = "./bolt_boltrifle.wav";
   description = AudioClosest3d;
   preload = true;
};

//audio
datablock AudioProfile(MilitarySniperFireSound)
{
   filename    = "./sniper_rifle_fire.wav";
   description = AudioClose3d;
   preload = true;
};
// datablock AudioProfile(MilitarySniperRicSound)
// {
//    filename    = "./Military_Sniper_Ricochet.wav";
//    description = AudioClose3d;
//    preload = true;
// };

// datablock ExplosionData(militarySniperExplosion)
// {
//    //explosionShape = "";
// 	soundProfile = MilitarySniperRicSound;

//    lifeTimeMS = 150;

//    particleEmitter = shotgunExplosionEmitter;
//    particleDensity = 5;
//    particleRadius = 0.2;

//    emitter[0] = gunExplosionRingEmitter;

//    faceViewer     = true;
//    explosionScale = "1 1 1";

//    shakeCamera = true;
//    camShakeFreq = "10.0 11.0 10.0";
//    camShakeAmp = "1.0 1.0 1.0";
//    camShakeDuration = 0.5;
//    camShakeRadius = 10.0;

//    // Dynamic light
//    lightStartRadius = 0;
//    lightEndRadius = 2;
//    lightStartColor = "0.3 0.6 0.7";
//    lightEndColor = "0 0 0";

//    impulseRadius = 2;
//    impulseForce = 1000;
// };

AddDamageType("MilitaryRifle",   '<bitmap:add-ons/Weapon_Package_Tier2/CI_MilitaryRifle> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier2/CI_MilitaryRifle> %1',0.75,1);
AddDamageType("MilitaryRifleHeadshot",   '<bitmap:add-ons/Weapon_Package_Tier2/CI_MilitaryRifle> <bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier2/CI_MilitaryRifle> <bitmap:add-ons/Weapon_Package_Tier2/CI_tactheadshot> %1',0.75,1);

// datablock ProjectileData(MilitarySniperProjectile : shotgunBlastProjectile)
// {
//    directDamage        = 0;
//    directDamageType    = $DamageType::MilitaryRifle;
//    radiusDamageType    = $DamageType::MilitaryRifle;

//    brickExplosionRadius = 0.4;
//    brickExplosionImpact = true;          //destroy a brick if we hit it directly?
//    brickExplosionForce  = 30;
//    brickExplosionMaxVolume = 25;          //max volume of bricks that we can destroy
//    brickExplosionMaxVolumeFloating = 35;  //max volume of bricks that we can destroy if they aren't connected to the ground

//    impactImpulse	     = 300;
//    verticalImpulse     = 100;
//    explosion           = militarySniperExplosion;

//    muzzleVelocity      = 100;
//    velInheritFactor    = 1;

//    armingDelay         = 0;
//    lifetime            = 70;
//    fadeDelay           = 0;
//    isBallistic         = true;
//    gravityMod = 0.0;
// };

datablock ProjectileData(milTracerProjectile : pistolTracerProjectile)
{
   directDamage        = 1;
   directDamageType    = $DamageType::MilitaryRifle;
   muzzleVelocity      = 200;
   radiusDamageType    = $DamageType::MilitaryRifle;
};

//////////
// item //
//////////
datablock ItemData(MilitarySniperItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./sniper_rifle.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Sniper Rifle";
	iconName = "./sniperrifle";
	doColorShift = true;
	colorShiftColor = "0.3 0.3 0.3 1.000";

	 // Dynamic properties defined by the scripts
	image = MilitarySniperImage;
	canDrop = true;

   TT_ammoType = "270";
   TT_reloads = true;
	TT_maxAmmo = 4;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(MilitarySniperImage)
{
	TT_raycastEnabled = true;
   TT_raycastWeaponRange = 900;
   TT_raycastWeaponTargets =
                   $TypeMasks::PlayerObjectType |    //AI/Players
                   $TypeMasks::StaticObjectType |    //Static Shapes
                   $TypeMasks::TerrainObjectType |    //Terrain
                   $TypeMasks::VehicleObjectType |    //Terrain
                   $TypeMasks::FXBrickObjectType;    //Bricks
   TT_raycastExplosionProjectile = shotgunBlastProjectile;
   TT_raycastTracerProjectile = milTracerProjectile;
   TT_raycastCritTracerProjectile = milTracerProjectile;
   TT_raycastExplosionBrickSound = bulletHitSound;
   TT_raycastExplosionPlayerSound = bulletHitSound;
   TT_raycastCritDirectDamageType = $DamageType::MilitaryRifleHeadshot;
   TT_raycastDirectDamage = 33; // 100 //Varies
   TT_raycastDirectDamageType = $DamageType::MilitaryRifle;
   TT_raycastSpreadAmt = 0; //Varies

   // Basic Item properties
	shapeFile = "./sniper_rifle.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = MilitarySniperItem;
   ammo = " ";
   projectile = milTracerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   minShotTime = 1450;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift = true;
   colorShiftColor = MilitarySniperItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.192; // 0.2
	stateTransitionOnTimeout[0]     = "DeathCheckA";
	stateSound[0]			  = weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNotLoaded[1] = "Reload";
	stateTransitionOnTriggerDown[1] = "FireCheckA";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Wait2";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateEmitter[2]			  = gunFlashEmitter;
	stateEmitterTime[2]		  = 0.05;
	stateEmitterNode[2]		  = "muzzleNode";
	stateSound[2]			  = militarysniperfireSound;

	stateName[3] 			  = "Smoke";
	stateSequence[3]			  = "eject";
	stateSound[3]			  = boltriflereloadSound;
	stateTimeoutValue[3]            = 0.7;
	stateScript[3]                  = "onSmoke";
	stateTransitionOnTimeout[3]     = "Wait3";

	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "TT_onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnLoaded[5]		= "Ready";
	stateTransitionOnNotLoaded[5]		= "Empty";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 0.2;
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Reload1";
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.3;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]                   = "Empty";
	stateTransitionOnLoaded[8]      = "Ready";
	stateTransitionOnAmmo[8]  = "Reload";
	stateTransitionOnTriggerDown[8]     = "FireCheckA";

	stateName[9]                    = "EmptyFire";
	stateScript[9]                  = "TT_onEmptyFire";
	stateTransitionOnLoaded[9]      = "Ready";
	stateTransitionOnAmmo[9]        = "Reload";
	stateTransitionOnTriggerUp[9]   = "Empty";

	stateName[10]                    = "FireCheckA";
	stateScript[10]                  = "TT_onFireCheck";
	stateTransitionOnTimeout[10]     = "FireCheckB";

	stateName[11]                    = "FireCheckB";
	stateTransitionOnLoaded[11]   = "Fire";
	stateTransitionOnNotLoaded[11]      = "EmptyFire";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.384; // 0.4
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "DeathCheckA";

	stateName[13] 			  = "Wait2";
	stateTimeoutValue[13]            = 0.672; // 0.7
	stateTransitionOnTimeout[13]     = "DeathCheckA";

	stateName[14] 			  = "Wait3";
	stateTimeoutValue[14]            = 0.7;
	stateTransitionOnTimeout[14]     = "LoadCheckA";

	stateName[15]				= "Reload1";
	stateTimeoutValue[15]			= 1.5;
	stateScript[15]				= "onReloaded1";
	stateTransitionOnTimeout[15]		= "Wait";

	stateName[16]            = "DeathCheckA";
	stateScript[16]          = "TT_onDeathCheck";
	stateTimeoutValue[16]        = 0.032;
	stateTransitionOnTimeout[16] = "DeathCheckB";

	stateName[17]             = "DeathCheckB";
	stateTransitionOnAmmo[17] = "Smoke";
};

///////// notes on the reload sequence:
///////// it goes (reloadsmoke)-reload-reload1-wait-reloaded
///////// complex, huh?
///////////////////////////////////

function MilitarySniperImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(block_PlantBrick_Sound,%obj.getPosition());
}

function MilitarySniperImage::onReloaded1(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftleft);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
}

function MilitarySniperImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	serverPlay3D(block_ChangeBrick_Sound,%obj.getPosition());
	%obj.playThread(2, shiftRight);
}

function MilitarySniperImage::onSmoke(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
}

function MilitarySniperImage::onReloaded(%this,%obj,%slot)
{
	// %obj.setImageLoaded(%slot, 1) not necessary since it goes straight to DeathCheckA
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}

// function MilitarySniperImage::onMount(%this,%obj,%slot)
// {
//    Parent::onMount(%this,%obj,%slot);
//    %obj.lastFireTime = getSimTime() - 500; // useless, see onFire
// }

function MilitarySniperImage::onFire(%this,%obj,%slot)
{
	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");

	TT_knockback(%obj, -4, -4, -4);

	// pretty sure its almost impossible for this to trigger given how slowly the sniper fires, commenting out for now
	// if((%obj.lastFireTime+%this.minShotTime) > getSimTime())
	// {
	// 	%this.TT_raycastExplosionProjectile = militarySniperProjectile;
	// 	%this.TT_raycastSpreadAmt = ((%obj.lastFireTime+%this.minShotTime) - getSimTime())/%this.minShotTime*0.005;
	// 	%this.TT_raycastDirectDamage = 30;
	// }
	// else
	// {
	// 	%this.TT_raycastExplosionProjectile = shotgunBlastProjectile;
	// 	%this.TT_raycastSpreadAmt = 0;
	// 	%this.TT_raycastDirectDamage = 33;
	// }
	
	Parent::onFire(%this,%obj,%slot);

	// have no idea what this is checking for, commenting out for now
	// if(!%obj.fireTrace) 
	// {
	// 	%obj.lastFireTime = getSimTime();
	%obj.playThread(2, plant);

	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);
	// }
}

function MilitarySniperImage::TT_isRaycastCritical(%this, %obj, %slot, %col, %pos, %normal, %hit)
{
	return TT_isRaycastHeadshot(%this, %obj, %slot, %col, %pos, %normal, %hit);
}
