if($Pref::Server::TT::DisableNadePickups)
{
   warn("WARNING: Weapon_Package_Explosive1 - grenade pickup items disabled");
   return;
}

datablock ItemData(GrenadeBagItem)
{
   category = "Weapon";  // Mission editor category
   className = "Weapon"; // For inventory system
   shapeFile = "./grenade_bag.dts";
   mass = 1;
   density = 0.2;
   elasticity = 0.2;
   friction = 0.6;
   emap = true;
   rotate = true;
   uiName = "Grenade Bag";
   doColorShift = false;
   colorShiftColor = "0.471 0.471 0.471 1.000";
   canDrop = true;

   TT_ammoPickup = true;
   TT_ammoPickup[0] = "fragNades 2";
   TT_ammoPickup[1] = "stickNades 1";
   TT_ammoPickup[2] = "molNades 2";
};

function GrenadeBagItem::onAdd(%this, %obj)
{
   %this.TT_initAmmoPickup(%obj);
   %obj.rotate = true;
   Parent::onAdd(%this, %obj);
}
