//audio
datablock AudioProfile(CombatShotgunFireSound)
{
   filename    = "./Combat_shotgun_fire.wav";
   description = AudioClose3d;
   preload = true;
};

// datablock ProjectileData(CombatShotgunFlashProjectile : ShotgunFlashProjectile)
// {
//    explosion           = shotgunExplosion;
// };

// datablock ParticleData(shotgunShineParticle)
// {
// 	dragCoefficient      = 8;
// 	gravityCoefficient   = 1;
// 	inheritedVelFactor   = 0.2;
// 	constantAcceleration = 0.0;
// 	lifetimeMS           = 200;
// 	lifetimeVarianceMS   = 00;
// 	textureName          = "./anamorphicyellow";
// 	spinSpeed		= 10.0;
// 	spinRandomMin		= -50.0;
// 	spinRandomMax		= 50.0;
// 	colors[0]     = "1 1 1 1";
// 	colors[1]     = "1 1 1 0.0";
// 	sizes[0]      = 1.25;
// 	sizes[1]      = 1.35;

// 	useInvAlpha = true;
// };

// datablock ParticleEmitterData(shotgunShineEmitter)
// {
//    ejectionPeriodMS = 1;
//    periodVarianceMS = 0;
//    ejectionVelocity = 2;
//    velocityVariance = 1.0;
//    ejectionOffset   = 0.0;
//    thetaMin         = 89;
//    thetaMax         = 90;
//    phiReferenceVel  = 0;
//    phiVariance      = 360;
//    overrideAdvance = false;
//    particles = "shotgunShineParticle";
// };

// datablock ExplosionData(shotgunShine)
// {
//    lifeTimeMS = 150;

//    particleEmitter = shotgunShineEmitter;
//    particleDensity = 5;
//    particleRadius = 0.2;

//    faceViewer     = true;
//    explosionScale = "1 1 1";

//    shakeCamera = false;
//    camShakeFreq = "10.0 11.0 10.0";
//    camShakeAmp = "1.0 1.0 1.0";
//    camShakeDuration = 0.5;
//    camShakeRadius = 10.0;

//    // Dynamic light
//    lightStartRadius = 0;
//    lightEndRadius = 2;
//    lightStartColor = "0.3 0.6 0.7";
//    lightEndColor = "0 0 0";
// };

// datablock ProjectileData(ShotgunShineProjectile : ShotgunFlashProjectile)
// {
//    explosion           = shotgunShine;
// };

AddDamageType("CombatShotgun",   '<bitmap:add-ons/Weapon_Package_Tier2/CI_AutoShotgun> %1',    '%2 <bitmap:add-ons/Weapon_Package_Tier2/CI_AutoShotgun> %1',2,1);
datablock ProjectileData(CombatShotgunProjectile)
{
   projectileShapeName = "add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 9; //14;
   directDamageType    = $DamageType::CombatShotgun;
   radiusDamageType    = $DamageType::CombatShotgun;

   brickExplosionRadius = 0.2;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 15;
   brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 30;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 200;
   verticalImpulse     = 100;
   explosion           = gunExplosion;

   muzzleVelocity      = 120;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0.4;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};

datablock ProjectileData(CombatShotgunBlastProjectile : ShotgunBlastProjectile)
{
   directDamageType    = $DamageType::CombatShotgun;
   radiusDamageType    = $DamageType::CombatShotgun;
};

// datablock ProjectileData(CombatShotgunDoubleshotProjectile)
// {
//    projectileShapeName = "add-ons/weapon_package_tier1/rifle_round.dts";
//    directDamage        = 15; //14;
//    directDamageType    = $DamageType::CombatShotgun;
//    radiusDamageType    = $DamageType::CombatShotgun;

//    brickExplosionRadius = 0.2;
//    brickExplosionImpact = true;          //destroy a brick if we hit it directly?
//    brickExplosionForce  = 15;
//    brickExplosionMaxVolume = 20;          //max volume of bricks that we can destroy
//    brickExplosionMaxVolumeFloating = 30;  //max volume of bricks that we can destroy if they aren't connected to the ground

//    impactImpulse	     = 200;
//    verticalImpulse     = 100;
//    explosion           = gunExplosion;

//    particleEmitter     = pistolTrailEmitter;

//    muzzleVelocity      = 120;
//    velInheritFactor    = 1;

//    armingDelay         = 0;
//    lifetime            = 4000;
//    fadeDelay           = 3500;
//    bounceElasticity    = 0.5;
//    bounceFriction      = 0.20;
//    isBallistic         = true;
//    gravityMod = 0.4;

//    hasLight    = false;
//    lightRadius = 3.0;
//    lightColor  = "0 0 0.5";
// };


//////////
// item //
//////////
datablock ItemData(CombatShotgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Spas.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Combat Shotgun";
	iconName = "./combatshotgun";
	doColorShift = true;
	colorShiftColor = "0.5 0.5 0.51 1.000";

	 // Dynamic properties defined by the scripts
	image = CombatShotgunImage;
	canDrop = true;

	TT_ammoType = "shotgun";
	TT_reloads = true;
	TT_maxAmmo = 7;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(CombatShotgunImage : PumpShotgunImage)
{
   // Basic Item properties
   shapeFile = "./Spas.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = CombatShotgunItem;
   ammo = " ";
   projectile = CombatShotgunProjectile;
   projectileType = Projectile;

   casing = PumpShotgunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1000;

   doColorShift = true;
   colorShiftColor = CombatShotgunItem.colorShiftColor;

   // hook into Support_ImageAltTrigger
   altTriggerEnabled = true;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.128; //0.15
	stateTransitionOnTimeout[0]     = "DeathCheckA";
	stateSound[0]			  = weaponSwitchSound;

	stateName[1]                    	= "Ready";
	stateTransitionOnTriggerDown[1] 	= "FireDelay";
	stateTransitionOnNotLoaded[1]		= "ReloadCheckA";
	stateScript[1]                  = "onReady";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.1;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";

	stateName[3] 			  = "Smoke";
	stateTimeoutValue[3]            = 0.192; //0.2
	stateTransitionOnTimeout[3]     = "DeathCheckA";

	stateName[4]			  = "Eject";
	stateTimeoutValue[4]		  = 0.48; //0.5
	stateTransitionOnTimeout[4]	  = "LoadCheckA";
	stateEjectShell[4]       	  = true;
	stateSequence[4]			  = "fire";
	stateSound[4]			  = PumpShotgunReloadSound;
	stateScript[4]                  = "onEject";

	stateName[5]            = "LoadCheckA";
	stateTimeoutValue[5]    = 0.01;
	stateScript[5]          = "TT_onLoadCheck";
	stateTransitionOnTimeout[5] = "WaitForTriggerUp";

	stateName[6]				= "LoadCheckB";
	stateTransitionOnLoaded[6]		= "Ready";
	stateTransitionOnAmmo[6]		= "Reload";
	stateTransitionOnNoAmmo[6]    = "Empty";
	
	stateName[7]				= "ReloadCheckA";
	stateScript[7]				= "TT_onReloadCheck";
	stateTimeoutValue[7]			= 0.01;
	stateTransitionOnTimeout[7]		= "ReloadCheckB";
						
	stateName[8]				= "ReloadCheckB";
	stateTransitionOnLoaded[8]		= "CompleteReload";
	stateTransitionOnNotLoaded[8]		= "LoadCheckB";

	stateName[9]                  = "Empty";
	stateTransitionOnLoaded[9]      = "Ready";
	stateTransitionOnAmmo[9]       = "Reload";
	stateTransitionOnTriggerDown[9] = "Fire";

	stateName[10]				= "Reload";
	stateTransitionOnTimeout[10]     	= "Reloaded";
	stateTransitionOnTriggerDown[10] 	= "Fire";
	stateTimeoutValue[10]			= 0.25;
	stateScript[10]				= "onReloadStart";

	stateName[11]				= "Reloaded";
	stateTransitionOnTimeout[11]     	= "ReloadCheckA";
	stateTimeoutValue[11]			= 0.2;
	stateScript[11]				= "onReloaded";

	stateName[12]			  = "CompleteReload";
	stateTimeoutValue[12]		  = 0.5;
	stateTransitionOnTimeout[12]     	= "Ready";
	stateSequence[12]			  = "fire";
	stateSound[12]			  = PumpShotgunReloadSound;
	stateScript[12]                  = "onEject";

	stateName[13]				= "FireDelay";
	stateTimeoutValue[13]		  = 0.01;
	stateTransitionOnTimeout[13]     	= "Fire";

	stateName[14]                  = "WaitForTriggerUp";
	stateTransitionOnTriggerUp[14]   = "LoadCheckB";

	stateName[15]                  = "DeathCheckA";
	stateTimeoutValue[15]          = 0.01;
	stateScript[15]                = "TT_onDeathCheck";
	stateTransitionOnTimeout[15]   = "DeathCheckB";

	stateName[16]                  = "DeathCheckB";
	stateTransitionOnAmmo[16]      = "Eject";
	// stateTransitionOnNoAmmo[16]    = "Empty";
};

function CombatShotgunImage::onFire(%this,%obj,%slot)
{
	if(%this.TT_canFire(%obj))
	{
		serverPlay3D(CombatShotgunfireSound,%obj.getPosition());
		%obj.playThread(2, activate);
		
		%this.TT_decrementAmmo(%obj);

		if($Pref::Server::TT::Recoil)
			%obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");

		%projectile = %this.projectile;
		%spread = 0.0027;
		%shellCount = 9;

		%p = TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);

		//just the muzzleflash
		//
		//nothing really special about this
		///////////////////////////////////////////////////////////

		// TT_createProjectile(%this, %obj, %slot, shotgunFlashProjectile, 1);
	
		//shotgun blast projectile: only effective at point blank, sends targets flying off into the distance
		//
		//more or less represents the concussion blast. i can only assume such a thing exists because
		// i've never stood infront of a fucking shotgun before
		///////////////////////////////////////////////////////////

		TT_createProjectile(%this, %obj, %slot, CombatShotgunBlastProjectile, 1);
	}
	else if(!$Pref::Server::TT::DeathStopFiring || %obj.getDamagePercent() < 1.0)
	{
		serverPlay3D(PumpShotgunJamSound,%obj.getPosition());
	}
	%this.TT_displayAmmo(%obj);
	return %p;
}

function CombatShotgunImage::onEject(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	%this.TT_displayAmmo(%obj);
}

function CombatShotgunImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.playThread(2, shiftto);
	serverPlay3D(block_MoveBrick_Sound,%obj.getPosition());
	%this.TT_displayAmmo(%obj);
}

function CombatShotgunImage::onReloaded(%this,%obj,%slot)
{
	%this.TT_incrementReload(%obj, %slot);
	%this.TT_displayAmmo(%obj);
}

function CombatShotgunImage::onAltTrigger(%this,%obj,%objDB,%triggerSlot,%val)
{
	if(%val && %triggerSlot == 4)
	{
		%obj.TT_retainImageAmmo = 1;
		%obj.mountImage(combatShotgunAltfireImage, 0);
	}
}

datablock ShapeBaseImageData(CombatShotgunAltfireImage)
{
   // Basic Item properties
   shapeFile = "./Spas.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = CombatShotgunItem;
   ammo = " ";
   projectile = CombatShotgunProjectile;
   projectileType = Projectile;

   casing = PumpShotgunShellDebris;
   shellExitDir        = "1.0 0.1 1.0";
   shellExitOffset     = "0 0 0";
   shellExitVariance   = 10.0;	
   shellVelocity       = 5.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   minShotTime = 1000;

   doColorShift = true;
   colorShiftColor = CombatShotgunItem.colorShiftColor;

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.01;
	stateSequence[0]			  = "Activate";
	stateScript[0]                  = "onActivate";
	stateTransitionOnTimeout[0]     = "Eject";

	stateName[1]			  = "Eject";
	stateTimeoutValue[1]		  = 0.3;
	stateTransitionOnTimeout[1]	  = "Fire";
	stateWaitForTimeout[1]		  = true;
	stateSequence[1]			  = "fire";
	stateSound[1]			  = PumpShotgunReloadSound;
	stateScript[1]                  = "onEject";
	
	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Cooldown";
	stateTimeoutValue[2]            = 0.3;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";

	stateName[3]			  = "Cooldown";
	stateTimeoutValue[3]		  = 0.5;
	stateTransitionOnTimeout[3]	  = "Done";

	stateName[4]			  = "Done";
	stateTimeoutValue[4]		  = 0.8;
	//stateTransitionOnTimeout[4]	  = "Ready";
	stateScript[4]                  = "onDone";
};

function combatShotgunAltfireImage::onDone(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%obj.TT_retainImageAmmo = 1;
	%obj.mountImage(CombatShotgunImage, %slot);
}

function CombatShotgunAltfireImage::onFire(%this,%obj,%slot)
{
	if(%this.TT_canFire(%obj, 2))
	{
		serverPlay3D(CombatShotgunfireSound,%obj.getPosition());
		%obj.playThread(2, activate);

		%this.TT_decrementAmmo(%obj, 2);

		if($Pref::Server::TT::Recoil)
			%obj.spawnExplosion(TTBigRecoilProjectile,"1 1 1");

		%projectile = %this.projectile;
		%spread = 0.0027;
		%shellcount = 16;

		%p = TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
		
		//shotgun blast projectile: only effective at point blank, sends targets flying off into the distance
		//
		//more or less represents the concussion blast. i can only assume such a thing exists because
		// i've never stood infront of a fucking shotgun before
		///////////////////////////////////////////////////////////

		%projectile = CombatShotgunBlastProjectile;
		%spread = 0.0009;
		%shellcount = 4;

		TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);

		//just the muzzleflash
		//
		//nothing really special about this
		///////////////////////////////////////////////////////////

		// TT_createProjectile(%this, %obj, %slot, shotgunFlashProjectile, 1);
	}
	else if(!$Pref::Server::TT::DeathStopFiring || %obj.getDamagePercent() < 1.0)
	{
		serverPlay3D(PumpShotgunJamSound,%obj.getPosition());
	}
	%this.TT_displayAmmo(%obj);
	return %p;
}

function CombatShotgunAltfireImage::onActivate(%this,%obj,%slot)
{
	%obj.playThread(2, activate);
	%this.TT_displayAmmo(%obj);
}

function CombatShotgunAltfireImage::onEject(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	%this.TT_displayAmmo(%obj);
}
