AddDamageType("RetroRifle",   '<bitmap:add-ons/Weapon_Skins_Rifles/CI_replica_rifle> %1',    '%2 <bitmap:add-ons/Weapon_Skins_Rifles/ci_replica_rifle> %1',0.75,1);
AddDamageType("RetroRifleHeadshot",   '<bitmap:add-ons/Weapon_Skins_Rifles/ci_replica_rifle> <bitmap:add-ons/Weapon_Package_Tier1/CI_tactheadshot>%1',    '%2 <bitmap:add-ons/Weapon_Skins_Rifles/ci_replica_rifle> <bitmap:add-ons/Weapon_Package_Tier1/CI_tactheadshot>%1',0.75,1);

////////////////////////////////////////////////////////////////////////////////////////////////projectile
datablock ProjectileData(RetroRifleProjectile : SportRifleProjectile)
{
   // directDamage        = sportrifleprojectile.directdamage; //90
   directDamageType    = $DamageType::RetroRifle;
   radiusDamageType    = $DamageType::RetroRifle;
};

datablock ProjectileData(RetroRifleWeakProjectile : SportRifleWeakProjectile)
{
   directDamageType    = $DamageType::RetroRifle;
   radiusDamageType    = $DamageType::RetroRifle;
   // directDamage        = sportrifleweakprojectile.directdamage; //90
};


////////////////////////////////////////////////////////////////////////////////////////////////item
datablock ItemData(RetroRifleItem : SportRifleItem)
{
	shapeFile = "./KAR98.1.dts";
	uiName = "Bolt-Action Rifle";
	iconName = "./boltactionrifle";
	colorShiftColor = "0.41 0.33 0.26 1";
	image = RetroRifleImage;
	TT_ammoType = "556";
	TT_reloads = true;
	TT_maxAmmo = 7;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(RetroRifleImage : SportRifleImage)
{
	shapeFile = "./KAR98.1.dts";
   item = RetroRifleItem;
   projectile = RetroRifleProjectile;
	offset = "0 0 0.1";
   projectileType = Projectile;
   doColorShift = true;
   colorShiftColor = RetroRifleItem.colorShiftColor;

	stateName[0]                    = "Activate";
	stateTimeoutValue[0]            = 0.25;
	// stateSequence[0]			  = "Activate";
	stateTransitionOnTimeout[0]     = "LoadCheckA";
	stateSound[0]			  = weaponSwitchSound;

	stateName[1]                    = "Ready";
	stateTransitionOnNotLoaded[1] = "Reload";
	stateTransitionOnTriggerDown[1] = "FireCheckA";
	// stateSequence[1]			  = "ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "DeathCheckA";
	stateTransitionOnTriggerUp[2]   = "DeathCheckA";
	stateTimeoutValue[2]            = 0.22;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateScript[2]                  = "onFire";
	stateEmitter[2]			  = gunFlashEmitter;
	stateEmitterTime[2]		  = 0.05;
	stateEmitterNode[2]		  = "muzzleNode";
	stateSound[2]			  = SportRiflefireSound;

	stateName[3] 			  = "Smoke";
	stateSequence[3]			  = "pump";
	stateEmitter[3]			  = gunSmokeEmitter;
	stateEmitterTime[3]		  = 0.1;
	stateEmitterNode[3]		  = "muzzleNode";
	stateScript[3]				= "onSmoke";
	stateTimeoutValue[3]            = 0.576; // 0.6
	stateSound[3]			  = LeverRifleClickSound;
	stateTransitionOnTimeout[3]     = "LoadCheckA";

	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "TT_onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnLoaded[5]		= "Ready";
	stateTransitionOnNotLoaded[5]		= "Empty";

	stateName[6]				= "Reload";
	stateTimeoutValue[6]			= 1.4;
	stateScript[6]				= "onReloadStart";
	stateTransitionOnTimeout[6]		= "Wait";
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.5;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";

	stateName[8]				= "Reloaded";
	stateTimeoutValue[8]			= 0.1;
	stateScript[8]				= "onReloaded";
	stateTransitionOnTimeout[8]		= "Ready";

	stateName[9]				= "FireCheckA";
	stateScript[9]				= "TT_onFireCheck";
	stateTransitionOnTimeout[9]		= "FireCheckB";

	stateName[10]				= "FireCheckB";
	stateTransitionOnLoaded[10]		= "Fire";
	stateTransitionOnNotLoaded[10]		= "EmptyFire";

	stateName[11] 				= "Empty";
	stateTransitionOnAmmo[11]			= "Reload";
	stateTransitionOnTriggerDown[11]			= "FireCheckA";

	stateName[12]                    = "EmptyFire";
	stateScript[12]                  = "TT_onEmptyFire";
	stateTransitionOnAmmo[12]        = "Reload";
	stateTransitionOnTriggerUp[12]   = "Empty";

	stateName[13]                    = "DeathCheckA";
	stateScript[13]                  = "TT_onDeathCheck";
	stateTimeoutValue[13]            = 0.032;
	stateTransitionOnTimeout[13]        = "DeathCheckB";

	stateName[14]                    = "DeathCheckB";
	stateTransitionOnAmmo[14]        = "Smoke";
};


function RetroRifleImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	
	if(vectorLen(%obj.getVelocity()) < 4 && (getSimTime() - %obj.lastShotTime) > 1000)
	{
		%projectile = %this.projectile;
		%spread = 0.0000;
	}
	else
	{
		%projectile = RetroRifleWeakProjectile;
		%spread = 0.00015;
	}
	%shellCount = 1;
	
	%this.TT_decrementAmmo(%obj);
	%this.TT_displayAmmo(%obj);

	if($Pref::Server::TT::Recoil)
		%obj.spawnExplosion(TTRecoilProjectile,"1 1 1");

	return TT_createProjectile(%this, %obj, %slot, %projectile, %shellCount, %spread);
}

function RetroRifleImage::onSmoke(%this,%obj,%slot)
{
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftLeft);
}

function RetroRifleImage::onReloadStart(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, shiftRight);
	serverPlay3D(block_MoveBrick_Sound, %obj.getPosition());
}

function RetroRifleImage::onReloadWait(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return;
	%this.TT_displayAmmo(%obj);
	%obj.playThread(2, plant);
	serverPlay3D(magazineOutSound, %obj.getPosition());
}

function RetroRifleImage::onReloaded(%this,%obj,%slot)
{
	if($Pref::Server::TT::DeathStopAnims && %obj.getDamagePercent() >= 1.0)
		return %obj.setImageLoaded(%slot, 1);
	%this.TT_reload(%obj, %slot, reloadClick8Sound, plant);
	%this.TT_displayAmmo(%obj);
}

function RetroRifleProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	TT_processHeadshotDamage(%this, %obj, %col, %pos, %this.directDamage, 2, $DamageType::RetroRifleHeadshot);
}

function RetroRifleWeakProjectile::damage(%this,%obj,%col,%fade,%pos,%normal)
{
	TT_processHeadshotDamage(%this, %obj, %col, %pos, %this.directDamage, 2, $DamageType::RetroRifleHeadshot);
}