//we need the tier 1 package for this, so force it to load
%error = ForceRequiredAddOn("Weapon_Package_Tier1");

if(%error == $Error::AddOn_NotFound)
{
   error("ERROR: Weapon_Package_Tier2 - required add-on Weapon_Package_Tier1 not found");
   return;
}

if($RTB::Hooks::ServerControl)
{
	// Check for Blockland Glass and if it is enabled, do a hack so we don't hog the pref list
	if(isFunction(registerPreferenceAddon))
		%mod = "Weapon_Package_Tier1";
	else
		%mod = "Weapon_Package_Tier2";

	RTB_registerPref("Light MG Slows On Fire","Tier+Tactical | Miscellaneous","$Pref::Server::TT::LMGSlow","bool",%mod,1,0,1);
}
else
{
   TT_defaultIfUnset("LMGSlow", 1);
}

exec("./Support_AltDatablock.cs");
exec("./Support_ImageAltTrigger.cs");
exec("./Weapon_Assault Rifle.cs");
exec("./Weapon_Battle Rifle.cs");
exec("./Weapon_Combat Shotgun.cs");
exec("./Weapon_Military Sniper.cs");
exec("./Weapon_Magnum.cs");
exec("./Weapon_LMG.cs");

// the scoped magnum: scrapped idea, simply because it's overpowered to go around one-shotting people as long as you hit them in their giant giant head. still kept in here though, as an easter egg.
if($Pref::Server::TT::EasterEgg)
{
	exec("./Weapon_ScopedMagnum.cs"); //
}
