function TT_defaultIfUnset(%pref, %default, %category)
{
   if(%category $= "")
      %category = "TT";
   if($Pref::Server["::" @ %category @ "::" @ %pref] $= "")
      $Pref::Server["::" @ %category @ "::" @ %pref] = %default;
}

if($RTB::Hooks::ServerControl)
{
	// Check for Blockland Glass and if it is enabled, do a hack so we don't hog the pref list
	if(isFunction(registerPreferenceAddon))
		%mod = "Weapon_Package_Tier1";
	else
		%mod = "Weapon_Melee_Extended_II";

   RTB_registerPref("Riot Shield Durability","Tier+Tactical | Melee","$Pref::Server::TT::ShieldDurability","int -1 1000",%mod,20,0,1);
   RTB_registerPref("Riot Shield Stops Falls","Tier+Tactical | Melee","$Pref::Server::TT::ShieldCancelFalling","bool",%mod,0,0,1);
   RTB_registerPref("Riot Shield Breaks for Bots","Tier+Tactical | Melee","$Pref::Server::TT::ShieldBreakBot","bool",%mod,1,0,1);
}
else
{
   TT_defaultIfUnset("ShieldDurability", 20);
   TT_defaultIfUnset("ShieldCancelFalling", 0);
   TT_defaultIfUnset("ShieldBreakBot", 1);
}

if(ForceRequiredAddOn("Weapon_Melee_Extended") == $Error::AddOn_NotFound)
{
   error("ERROR: Weapon_Melee_Extended_II - required add-on Weapon_Melee_Extended not found");
}
else
{
   exec("./Weapon_L4BCookingKnife.cs");
   exec("./Weapon_L4BKnifeonaStick.cs");
   exec("./Weapon_L4BChainsaw.cs");
   exec("./Weapon_L4BPaddle.cs");
   if($Pref::Server::TT::EasterEgg)
   {
      // it is said that long ago, big stick cried out for bushido to smoothshade it. this offended him greatly. as punishment, he sealed it away for all eternity.
      exec("./Weapon_L4BBigStick.cs"); //
      exec("./Weapon_L4BPipeWrench.cs"); //
      exec("./Weapon_L4BGaff.cs"); //
   }
   exec("./Weapon_L4BNailbat.cs");
   exec("./Weapon_L4BAxe.cs");
   exec("./Weapon_ShieldRiotTT.cs");
}
